Index: pjproject/trunk/pjsip-apps/src/python/_pjsua.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/python/_pjsua.c	(revision 2158)
+++ pjproject/trunk/pjsip-apps/src/python/_pjsua.c	(revision 2163)
@@ -1270,29 +1172,19 @@
     pj_status_t status;
     PyObject *list;
-    
     pjsua_transport_id id[PJSIP_MAX_TRANSPORTS];
     unsigned c, i;
 
     PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }	
-    
+    PJ_UNUSED_ARG(pArgs);
+
     c = PJ_ARRAY_SIZE(id);
     status = pjsua_enum_transports(id, &c);
     
     list = PyList_New(c);
-    for (i = 0; i < c; i++) 
-    {     
-        int ret = PyList_SetItem(list, i, Py_BuildValue("i", id[i]));
-        if (ret == -1) 
-        {
-            return NULL;
-        }
-    }
-    
-    return Py_BuildValue("O",list);
+    for (i = 0; i < c; i++) {     
+        PyList_SetItem(list, i, Py_BuildValue("i", id[i]));
+    }
+    
+    return (PyObject*)list;
 }
 
@@ -1320,8 +1212,7 @@
 					     NULL, NULL);
 	PyObj_pjsua_transport_info_import(obj, &info);
-        return Py_BuildValue("O", obj);
+        return (PyObject*)obj;
     } else {
-        Py_INCREF(Py_None);
-        return Py_None;
+        return Py_BuildValue("");
     }
 }
@@ -1330,6 +1221,6 @@
  * py_pjsua_transport_set_enable
  */
-static PyObject *py_pjsua_transport_set_enable
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_transport_set_enable(PyObject *pSelf, 
+					       PyObject *pArgs)
 {
     pj_status_t status;
@@ -1339,11 +1230,10 @@
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "ii", &id, &enabled))
-    {
-        return NULL;
-    }	
-    status = pjsua_transport_set_enable(id, enabled);	
-    
-    return Py_BuildValue("i",status);
+    if (!PyArg_ParseTuple(pArgs, "ii", &id, &enabled)) {
+        return NULL;
+    }
+    status = pjsua_transport_set_enable(id, enabled);
+
+    return Py_BuildValue("i", status);
 }
 
@@ -1359,11 +1249,10 @@
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "ii", &id, &force))
-    {
+    if (!PyArg_ParseTuple(pArgs, "ii", &id, &force)) {
         return NULL;
     }	
     status = pjsua_transport_close(id, force);	
     
-    return Py_BuildValue("i",status);
+    return Py_BuildValue("i", status);
 }
 
@@ -1406,5 +1295,4 @@
 /*
  * py_pjsua_acc_config_default
- * !modified @ 051206
  */
 static PyObject *py_pjsua_acc_config_default(PyObject *pSelf, PyObject *pArgs)
@@ -1414,4 +1302,5 @@
 
     PJ_UNUSED_ARG(pSelf);
+    PJ_UNUSED_ARG(pArgs);
 
     if (!PyArg_ParseTuple(pArgs, "")) {
@@ -1435,11 +1324,8 @@
 
     PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "")) {
-        return NULL;
-    }
+    PJ_UNUSED_ARG(pArgs);
 
     count = pjsua_acc_get_count();
-    return Py_BuildValue("i",count);
+    return Py_BuildValue("i", count);
 }
 
@@ -1488,8 +1374,5 @@
 	
     PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "")) {
-        return NULL;
-    }
+    PJ_UNUSED_ARG(pArgs);
 
     id = pjsua_acc_get_default();
@@ -1500,11 +1383,9 @@
 /*
  * py_pjsua_acc_add
- * !modified @ 051206
  */
 static PyObject *py_pjsua_acc_add(PyObject *pSelf, PyObject *pArgs)
 {    
     int is_default;
-    PyObject * acObj;
-    PyObj_pjsua_acc_config * ac;
+    PyObject *pCfg;
     int acc_id;
     int status;
@@ -1512,13 +1393,14 @@
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "Oi", &acObj, &is_default)) {
-        return NULL;
-    }
-    
-    if (acObj != Py_None) {
+    if (!PyArg_ParseTuple(pArgs, "Oi", &pCfg, &is_default)) {
+        return NULL;
+    }
+    
+    if (pCfg != Py_None) {
 	pjsua_acc_config cfg;
+	PyObj_pjsua_acc_config *ac;
 
 	pjsua_acc_config_default(&cfg);
-        ac = (PyObj_pjsua_acc_config *)acObj;
+        ac = (PyObj_pjsua_acc_config *)pCfg;
         PyObj_pjsua_acc_config_export(&cfg, ac);
         status = pjsua_acc_add(&cfg, is_default, &acc_id);
@@ -1533,5 +1415,4 @@
 /*
  * py_pjsua_acc_add_local
- * !modified @ 051206
  */
 static PyObject *py_pjsua_acc_add_local(PyObject *pSelf, PyObject *pArgs)
@@ -1539,5 +1420,5 @@
     int is_default;
     int tid;
-    int p_acc_id;
+    int acc_id;
     int status;
 	
@@ -1548,8 +1429,53 @@
     }
 	
-    
-    status = pjsua_acc_add_local(tid, is_default, &p_acc_id);
-    
-    return Py_BuildValue("ii", status, p_acc_id);
+    status = pjsua_acc_add_local(tid, is_default, &acc_id);
+    
+    return Py_BuildValue("ii", status, acc_id);
+}
+
+/*
+ * py_pjsua_acc_set_user_data
+ */
+static PyObject *py_pjsua_acc_set_user_data(PyObject *pSelf, PyObject *pArgs)
+{    
+    int acc_id;
+    PyObject *pUserData, *old_user_data;
+    int status;
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "iO", &acc_id, &pUserData)) {
+        return NULL;
+    }
+
+    old_user_data = (PyObject*) pjsua_acc_get_user_data(acc_id);
+
+    status = pjsua_acc_set_user_data(acc_id, (void*)pUserData);
+
+    if (status == PJ_SUCCESS) {
+	Py_XINCREF(pUserData);
+	Py_XDECREF(old_user_data);
+    }
+
+    return Py_BuildValue("i", status);
+}
+
+/*
+ * py_pjsua_acc_get_user_data
+ */
+static PyObject *py_pjsua_acc_get_user_data(PyObject *pSelf, PyObject *pArgs)
+{    
+    int acc_id;
+    PyObject *user_data;
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "i", &acc_id)) {
+        return NULL;
+    }
+
+    user_data = (PyObject*) pjsua_acc_get_user_data(acc_id);
+
+    return user_data ? Py_BuildValue("O", user_data) : Py_BuildValue("");
 }
 
@@ -1560,15 +1486,18 @@
 {    
     int acc_id;
+    PyObject *user_data;
     int status;
 
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "i", &acc_id))
-    {
-        return NULL;
-    }
-	
-	
-    status = pjsua_acc_del(acc_id);	
+    if (!PyArg_ParseTuple(pArgs, "i", &acc_id)) {
+        return NULL;
+    }
+
+    user_data = (PyObject*) pjsua_acc_get_user_data(acc_id);
+    Py_XDECREF(user_data);
+
+    status = pjsua_acc_del(acc_id);
+
     return Py_BuildValue("i", status);
 }
@@ -1579,5 +1508,5 @@
 static PyObject *py_pjsua_acc_modify(PyObject *pSelf, PyObject *pArgs)
 {    	
-    PyObject * acObj;
+    PyObject *pCfg;
     PyObj_pjsua_acc_config * ac;
     int acc_id;
@@ -1586,13 +1515,13 @@
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "iO", &acc_id, &acObj)) {
-        return NULL;
-    }
-
-    if (acObj != Py_None) {
+    if (!PyArg_ParseTuple(pArgs, "iO", &acc_id, &pCfg)) {
+        return NULL;
+    }
+
+    if (pCfg != Py_None) {
 	pjsua_acc_config cfg;	
 
 	pjsua_acc_config_default(&cfg);
-        ac = (PyObj_pjsua_acc_config *)acObj;
+        ac = (PyObj_pjsua_acc_config*)pCfg;
         PyObj_pjsua_acc_config_export(&cfg, ac);
 
@@ -1634,6 +1563,6 @@
     int acc_id;
     int activity_id;
-    const char *activity_text;
-    const char *rpid_id;
+    const char *activity_text = NULL;
+    const char *rpid_id = NULL;
     pjrpid_element rpid;
     pj_status_t status;	
@@ -1642,5 +1571,6 @@
 
     if (!PyArg_ParseTuple(pArgs, "iiiss", &acc_id, &is_online,
-			  &activity_id, &activity_text, &rpid_id)) {
+			  &activity_id, &activity_text, &rpid_id)) 
+    {
         return NULL;
     }
@@ -1649,5 +1579,6 @@
     rpid.type = PJRPID_ELEMENT_TYPE_PERSON;
     rpid.activity = activity_id;
-    rpid.note = pj_str((char*)activity_text);
+    if (activity_text)
+	rpid.note = pj_str((char*)activity_text);
 
     if (rpid_id)
@@ -1682,5 +1613,4 @@
 /*
  * py_pjsua_acc_get_info
- * !modified @ 051206
  */
 static PyObject *py_pjsua_acc_get_info(PyObject *pSelf, PyObject *pArgs)
@@ -1699,11 +1629,10 @@
     status = pjsua_acc_get_info(acc_id, &info);
     if (status == PJ_SUCCESS) {
-	obj = (PyObj_pjsua_acc_info *)
-	    PyObj_pjsua_acc_info_new(&PyTyp_pjsua_acc_info,NULL, NULL);
+	obj = (PyObj_pjsua_acc_info*)
+	      PyObj_pjsua_acc_info_new(&PyTyp_pjsua_acc_info, NULL, NULL);
 	PyObj_pjsua_acc_info_import(obj, &info);
-        return Py_BuildValue("O", obj);
+        return (PyObject*)obj;
     } else {
-	Py_INCREF(Py_None);
-	return Py_None;
+	return Py_BuildValue("");
     }
 }
@@ -1711,5 +1640,4 @@
 /*
  * py_pjsua_enum_accs
- * !modified @ 241206
  */
 static PyObject *py_pjsua_enum_accs(PyObject *pSelf, PyObject *pArgs)
@@ -1717,34 +1645,25 @@
     pj_status_t status;
     PyObject *list;
-    
     pjsua_acc_id id[PJSUA_MAX_ACC];
     unsigned c, i;
 
     PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }	
+    PJ_UNUSED_ARG(pArgs);
+
     c = PJ_ARRAY_SIZE(id);
-    
     status = pjsua_enum_accs(id, &c);
+    if (status != PJ_SUCCESS)
+	c = 0;
     
     list = PyList_New(c);
-    for (i = 0; i < c; i++) 
-    {
-        int ret = PyList_SetItem(list, i, Py_BuildValue("i", id[i]));
-        if (ret == -1) 
-	{
-            return NULL;
-        }
-    }
-    
-    return Py_BuildValue("O",list);
+    for (i = 0; i < c; i++) {
+        PyList_SetItem(list, i, Py_BuildValue("i", id[i]));
+    }
+    
+    return (PyObject*)list;
 }
 
 /*
  * py_pjsua_acc_enum_info
- * !modified @ 241206
  */
 static PyObject *py_pjsua_acc_enum_info(PyObject *pSelf, PyObject *pArgs)
@@ -1756,4 +1675,5 @@
 
     PJ_UNUSED_ARG(pSelf);
+    PJ_UNUSED_ARG(pArgs);
 
     if (!PyArg_ParseTuple(pArgs, "")) {
@@ -1763,5 +1683,7 @@
     c = PJ_ARRAY_SIZE(info);
     status = pjsua_acc_enum_info(info, &c);
-    
+    if (status != PJ_SUCCESS)
+	c = 0;
+
     list = PyList_New(c);
     for (i = 0; i < c; i++) {
@@ -1772,142 +1694,8 @@
 	PyObj_pjsua_acc_info_import(obj, &info[i]);
 
-        PyList_SetItem(list, i, (PyObject *)obj);
-    }
-    
-    return Py_BuildValue("O",list);
-}
-
-/*
- * py_pjsua_acc_find_for_outgoing
- */
-static PyObject *py_pjsua_acc_find_for_outgoing(PyObject *pSelf, 
-						PyObject *pArgs)
-{    	
-    int acc_id;	
-    PyObject * url;
-    pj_str_t str;
-
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "O", &url))
-    {
-        return NULL;
-    }
-    str.ptr = PyString_AsString(url);
-    str.slen = strlen(PyString_AsString(url));
-	
-    acc_id = pjsua_acc_find_for_outgoing(&str);
-	
-    return Py_BuildValue("i", acc_id);
-}
-
-/*
- * py_pjsua_acc_find_for_incoming
- */
-static PyObject *py_pjsua_acc_find_for_incoming(PyObject *pSelf, 
-						PyObject *pArgs)
-{    	
-    int acc_id;	
-    PyObject * tmpObj;
-    PyObj_pjsip_rx_data * obj;
-    pjsip_rx_data * rdata;
-
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "O", &tmpObj))
-    {
-        return NULL;
-    }
-    if (tmpObj != Py_None)
-    {
-        obj = (PyObj_pjsip_rx_data *)tmpObj;
-        rdata = obj->rdata;
-        acc_id = pjsua_acc_find_for_incoming(rdata);
-    } else {
-        acc_id = pjsua_acc_find_for_incoming(NULL);
-    }
-    return Py_BuildValue("i", acc_id);
-}
-
-/*
- * py_pjsua_acc_create_uac_contact
- * !modified @ 061206
- */
-static PyObject *py_pjsua_acc_create_uac_contact(PyObject *pSelf, 
-						 PyObject *pArgs)
-{    	
-    int status;
-    int acc_id;
-    PyObject * pObj;
-    PyObj_pj_pool * p;
-    pj_pool_t * pool;
-    PyObject * strc;
-    pj_str_t contact;
-    PyObject * stru;
-    pj_str_t uri;
-
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "OiO", &pObj, &acc_id, &stru))
-    {
-        return NULL;
-    }
-    if (pObj != Py_None)
-    {
-        p = (PyObj_pj_pool *)pObj;
-        pool = p->pool;    
-        uri.ptr = PyString_AsString(stru);
-        uri.slen = strlen(PyString_AsString(stru));
-        status = pjsua_acc_create_uac_contact(pool, &contact, acc_id, &uri);
-    } else {
-        status = pjsua_acc_create_uac_contact(NULL, &contact, acc_id, &uri);
-    }
-    strc = PyString_FromStringAndSize(contact.ptr, contact.slen);
-	
-    return Py_BuildValue("O", strc);
-}
-
-/*
- * py_pjsua_acc_create_uas_contact
- * !modified @ 061206
- */
-static PyObject *py_pjsua_acc_create_uas_contact(PyObject *pSelf, 
-						 PyObject *pArgs)
-{    	
-    int status;
-    int acc_id;	
-    PyObject * pObj;
-    PyObj_pj_pool * p;
-    pj_pool_t * pool;
-    PyObject * strc;
-    pj_str_t contact;
-    PyObject * rObj;
-    PyObj_pjsip_rx_data * objr;
-    pjsip_rx_data * rdata;
-
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "OiO", &pObj, &acc_id, &rObj))
-    {
-        return NULL;
-    }
-    if (pObj != Py_None)
-    {
-        p = (PyObj_pj_pool *)pObj;
-        pool = p->pool;
-    } else {
-		pool = NULL;
-    }
-    if (rObj != Py_None)
-    {
-        objr = (PyObj_pjsip_rx_data *)rObj;
-        rdata = objr->rdata;
-    } else {
-        rdata = NULL;
-    }
-    status = pjsua_acc_create_uas_contact(pool, &contact, acc_id, rdata);
-    strc = PyString_FromStringAndSize(contact.ptr, contact.slen);
-	
-    return Py_BuildValue("O", strc);
+        PyList_SetItem(list, i, (PyObject*)obj);
+    }
+    
+    return (PyObject*)list;
 }
 
@@ -1915,6 +1703,5 @@
  * py_pjsua_acc_set_transport
  */
-static PyObject *py_pjsua_acc_set_transport
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_acc_set_transport(PyObject *pSelf, PyObject *pArgs)
 {    	
     int acc_id, transport_id;
@@ -1923,6 +1710,5 @@
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "ii", &acc_id, &transport_id))
-    {
+    if (!PyArg_ParseTuple(pArgs, "ii", &acc_id, &transport_id)) {
         return NULL;
     }	
@@ -1938,13 +1724,11 @@
  * py_pjsua_acc_pres_notify
  */
-static PyObject *py_pjsua_acc_pres_notify
-(PyObject *pSelf, PyObject *pArgs)
-{
-    static char reason_buf[64];
+static PyObject *py_pjsua_acc_pres_notify(PyObject *pSelf, 
+					  PyObject *pArgs)
+{
     int acc_id, state;
-    PyObject *arg_pres, *arg_msg_data;
+    PyObject *arg_pres, *arg_msg_data, *arg_reason;
     void *srv_pres;
     pjsua_msg_data msg_data;
-    const char *arg_reason;
     pj_str_t reason;
     pj_bool_t with_body;
@@ -1954,5 +1738,5 @@
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "iOisO", &acc_id, &arg_pres, 
+    if (!PyArg_ParseTuple(pArgs, "iOiOO", &acc_id, &arg_pres, 
 			  &state, &arg_reason, &arg_msg_data))
     {
@@ -1961,25 +1745,19 @@
     
     srv_pres = (void*) PyLong_AsLong(arg_pres);
-    pjsua_msg_data_init(&msg_data);
     with_body = (state != PJSIP_EVSUB_STATE_TERMINATED);
 
-    if (arg_reason) {
-	strncpy(reason_buf, arg_reason, sizeof(reason_buf));
-	reason.ptr = reason_buf;
-	reason.slen = strlen(arg_reason);
+    if (arg_reason && PyString_Check(arg_reason)) {
+	reason = PyString_ToPJ(arg_reason);
     } else {
 	reason = pj_str("");
     }
 
+    pjsua_msg_data_init(&msg_data);
     if (arg_msg_data && arg_msg_data != Py_None) {
         PyObj_pjsua_msg_data *omd = (PyObj_pjsua_msg_data *)arg_msg_data;
-        msg_data.content_type.ptr = PyString_AsString(omd->content_type);
-        msg_data.content_type.slen = PyString_Size(omd->content_type);
-        msg_data.msg_body.ptr = PyString_AsString(omd->msg_body);
-        msg_data.msg_body.slen = PyString_Size(omd->msg_body);
+        msg_data.content_type = PyString_ToPJ(omd->content_type);
+        msg_data.msg_body = PyString_ToPJ(omd->msg_body);
         pool = pjsua_pool_create("pytmp", POOL_SIZE, POOL_SIZE);
         translate_hdr(pool, &msg_data.hdr_list, omd->hdr_list);
-    } else if (arg_msg_data) {
-	Py_XDECREF(arg_msg_data);    
     }
 
@@ -2049,22 +1827,4 @@
     "_pjsua.Acc_Info[] _pjsua.acc_enum_info () "
     "Enum accounts info.";
-static char pjsua_acc_find_for_outgoing_doc[] =
-    "int _pjsua.acc_find_for_outgoing (string url) "
-    "This is an internal function to find the most appropriate account "
-    "to used to reach to the specified URL.";
-static char pjsua_acc_find_for_incoming_doc[] =
-    "int _pjsua.acc_find_for_incoming (PyObj_pjsip_rx_data rdata) "
-    "This is an internal function to find the most appropriate account "
-    "to be used to handle incoming calls.";
-static char pjsua_acc_create_uac_contact_doc[] =
-    "string _pjsua.acc_create_uac_contact (PyObj_pj_pool pool, "
-    "int acc_id, string uri) "
-    "Create a suitable URI to be put as Contact based on the specified "
-    "target URI for the specified account.";
-static char pjsua_acc_create_uas_contact_doc[] =
-    "string _pjsua.acc_create_uas_contact (PyObj_pj_pool pool, "
-    "int acc_id, PyObj_pjsip_rx_data rdata) "
-    "Create a suitable URI to be put as Contact based on the information "
-    "in the incoming request.";
 
 /* END OF LIB ACCOUNT */
@@ -2084,9 +1844,6 @@
 
     PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "")) {
-        return NULL;
-    }
-    
+    PJ_UNUSED_ARG(pArgs);
+
     pjsua_buddy_config_default(&cfg);
     obj = (PyObj_pjsua_buddy_config *) 
@@ -2102,14 +1859,8 @@
 static PyObject *py_pjsua_get_buddy_count(PyObject *pSelf, PyObject *pArgs)
 {    
-    int ret;
-
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "")) {
-        return NULL;
-    }
-    ret = pjsua_get_buddy_count();
-	
-    return Py_BuildValue("i", ret);
+    PJ_UNUSED_ARG(pSelf);
+    PJ_UNUSED_ARG(pArgs);
+
+    return Py_BuildValue("i", pjsua_get_buddy_count());
 }
 
@@ -2134,5 +1885,4 @@
 /*
  * py_pjsua_enum_buddies
- * !modified @ 241206
  */
 static PyObject *py_pjsua_enum_buddies(PyObject *pSelf, PyObject *pArgs)
@@ -2140,15 +1890,15 @@
     pj_status_t status;
     PyObject *list;
-    
     pjsua_buddy_id id[PJSUA_MAX_BUDDIES];
     unsigned c, i;
 
     PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "")) {
-        return NULL;
-    }	
+    PJ_UNUSED_ARG(pArgs);
+
     c = PJ_ARRAY_SIZE(id);
     status = pjsua_enum_buddies(id, &c);
+    if (status != PJ_SUCCESS)
+	c = 0;
+
     list = PyList_New(c);
     for (i = 0; i < c; i++) {
@@ -2156,15 +1906,37 @@
     }
     
-    return Py_BuildValue("O",list);
+    return (PyObject*)list;
+}
+
+/*
+ * py_pjsua_buddy_find
+ */
+static PyObject *py_pjsua_buddy_find(PyObject *pSelf, PyObject *pArgs)
+{    
+    PyObject *pURI;
+    pj_str_t uri;
+    pjsua_buddy_id buddy_id;
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "O", &pURI)) {
+        return NULL;
+    }
+
+    if (!PyString_Check(pURI))
+	return Py_BuildValue("i", PJSUA_INVALID_ID);
+
+    uri = PyString_ToPJ(pURI);
+    buddy_id = pjsua_buddy_find(&uri);
+
+    return Py_BuildValue("i", buddy_id);
 }
 
 /*
  * py_pjsua_buddy_get_info
- * !modified @ 071206
  */
 static PyObject *py_pjsua_buddy_get_info(PyObject *pSelf, PyObject *pArgs)
 {    	
     int buddy_id;
-    PyObj_pjsua_buddy_info * obj;
     pjsua_buddy_info info;
     int status;	
@@ -2178,11 +1950,13 @@
     status = pjsua_buddy_get_info(buddy_id, &info);
     if (status == PJ_SUCCESS) {
+	PyObj_pjsua_buddy_info *obj;
+
 	obj = (PyObj_pjsua_buddy_info *)
-	      PyObj_pjsua_buddy_config_new(&PyTyp_pjsua_buddy_info,NULL,NULL);
+	      PyObj_pjsua_buddy_config_new(&PyTyp_pjsua_buddy_info, 
+					   NULL, NULL);
 	PyObj_pjsua_buddy_info_import(obj, &info);	
-        return Py_BuildValue("O", obj);
+        return (PyObject*)obj;
     } else {
-	Py_INCREF(Py_None);
-	return Py_None;
+	return Py_BuildValue("");
     }
 }
@@ -2190,9 +1964,8 @@
 /*
  * py_pjsua_buddy_add
- * !modified @ 061206
  */
 static PyObject *py_pjsua_buddy_add(PyObject *pSelf, PyObject *pArgs)
 {   
-    PyObject * bcObj;
+    PyObject *pCfg;
     int buddy_id;
     int status;
@@ -2200,13 +1973,13 @@
     PJ_UNUSED_ARG(pSelf);
 
-    if (!PyArg_ParseTuple(pArgs, "O", &bcObj)) {
-        return NULL;
-    }
-
-    if (bcObj != Py_None) {
+    if (!PyArg_ParseTuple(pArgs, "O", &pCfg)) {
+        return NULL;
+    }
+
+    if (pCfg != Py_None) {
 	pjsua_buddy_config cfg;
-	PyObj_pjsua_buddy_config * bc;
-
-        bc = (PyObj_pjsua_buddy_config *)bcObj;
+	PyObj_pjsua_buddy_config *bc;
+
+        bc = (PyObj_pjsua_buddy_config *)pCfg;
 
 	pjsua_buddy_config_default(&cfg);
@@ -2214,4 +1987,5 @@
     
         status = pjsua_buddy_add(&cfg, &buddy_id);
+
     } else {
         status = PJ_EINVAL;
@@ -2228,4 +2002,5 @@
     int buddy_id;
     int status;
+    PyObject *user_data;
 
     PJ_UNUSED_ARG(pSelf);
@@ -2234,17 +2009,67 @@
         return NULL;
     }
-	
-	
-    status = pjsua_buddy_del(buddy_id);	
+
+    user_data = (PyObject*) pjsua_buddy_get_user_data(buddy_id);
+    Py_XDECREF(user_data);
+
+    status = pjsua_buddy_del(buddy_id);
+
     return Py_BuildValue("i", status);
 }
 
 /*
- * py_pjsua_buddy_subscribe_pres
- */
-static PyObject *py_pjsua_buddy_subscribe_pres(PyObject *pSelf, PyObject *pArgs)
+ * py_pjsua_buddy_set_user_data
+ */
+static PyObject *py_pjsua_buddy_set_user_data(PyObject *pSelf, PyObject *pArgs)
 {    
     int buddy_id;
     int status;
+    PyObject *user_data, *old_user_data;
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "iO", &buddy_id, &user_data)) {
+        return NULL;
+    }
+
+    old_user_data = (PyObject*) pjsua_buddy_get_user_data(buddy_id);
+
+    status = pjsua_buddy_set_user_data(buddy_id, (void*)user_data);
+
+    if (status == PJ_SUCCESS) {
+	Py_XINCREF(user_data);
+	Py_XDECREF(old_user_data);
+    }
+
+    return Py_BuildValue("i", status);
+}
+
+/*
+ * py_pjsua_buddy_get_user_data
+ */
+static PyObject *py_pjsua_buddy_get_user_data(PyObject *pSelf, PyObject *pArgs)
+{    
+    int buddy_id;
+    PyObject *user_data;
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "i", &buddy_id)) {
+        return NULL;
+    }
+
+    user_data = (PyObject*) pjsua_buddy_get_user_data(buddy_id);
+
+    return user_data? Py_BuildValue("O", user_data) : Py_BuildValue("");
+}
+
+/*
+ * py_pjsua_buddy_subscribe_pres
+ */
+static PyObject *py_pjsua_buddy_subscribe_pres(PyObject *pSelf, 
+					       PyObject *pArgs)
+{
+    int buddy_id;
+    int status;
     int subscribe;
 
@@ -2254,7 +2079,7 @@
         return NULL;
     }
-	
-	
-    status = pjsua_buddy_subscribe_pres(buddy_id, subscribe);	
+
+    status = pjsua_buddy_subscribe_pres(buddy_id, subscribe);
+
     return Py_BuildValue("i", status);
 }
@@ -2272,14 +2097,12 @@
         return NULL;
     }
-	
-	
+
     pjsua_pres_dump(verbose);	
-    Py_INCREF(Py_None);
-    return Py_None;
+
+    return Py_BuildValue("");
 }
 
 /*
  * py_pjsua_im_send
- * !modified @ 071206
  */
 static PyObject *py_pjsua_im_send(PyObject *pSelf, PyObject *pArgs)
@@ -2287,48 +2110,46 @@
     int status;
     int acc_id;
-    pj_str_t * mime_type, tmp_mime_type;
+    pj_str_t *mime_type, tmp_mime_type;
     pj_str_t to, content;
-    PyObject * st;
-    PyObject * smt;
-    PyObject * sc;
+    PyObject *pTo;
+    PyObject *pMimeType;
+    PyObject *pContent;
     pjsua_msg_data msg_data;
-    PyObject * omdObj;
-    PyObj_pjsua_msg_data * omd;
-    
+    PyObject *pMsgData;
     int user_data;
-    pj_pool_t *pool;
+    pj_pool_t *pool = NULL;
 
     PJ_UNUSED_ARG(pSelf);
 
     if (!PyArg_ParseTuple(pArgs, "iOOOOi", &acc_id, 
-		&st, &smt, &sc, &omdObj, &user_data))
-    {
-        return NULL;
-    }
-    if (smt != Py_None) {
+		&pTo, &pMimeType, &pContent, &pMsgData, &user_data))
+    {
+        return NULL;
+    }
+
+    if (pMimeType != Py_None) {
         mime_type = &tmp_mime_type;
-	tmp_mime_type = PyString_to_pj_str(smt);
+	tmp_mime_type = PyString_ToPJ(pMimeType);
     } else {
         mime_type = NULL;
     }
-    to = PyString_to_pj_str(st);
-        content = PyString_to_pj_str(sc);
-
-    if (omdObj != Py_None) {
-		
-        omd = (PyObj_pjsua_msg_data *)omdObj;
-	msg_data.content_type = PyString_to_pj_str(omd->content_type);
-	msg_data.msg_body = PyString_to_pj_str(omd->msg_body);
-        pool = pjsua_pool_create("pjsua", POOL_SIZE, POOL_SIZE);
-
+
+    to = PyString_ToPJ(pTo);
+    content = PyString_ToPJ(pContent);
+
+    if (pMsgData != Py_None) {
+	PyObj_pjsua_msg_data *omd;
+
+        omd = (PyObj_pjsua_msg_data *)pMsgData;
+	msg_data.content_type = PyString_ToPJ(omd->content_type);
+	msg_data.msg_body = PyString_ToPJ(omd->msg_body);
+        pool = pjsua_pool_create("pytmp", POOL_SIZE, POOL_SIZE);
         translate_hdr(pool, &msg_data.hdr_list, omd->hdr_list);
-        status = pjsua_im_send(acc_id, &to, mime_type, 
-			&content, &msg_data, (void *)user_data);	
-        pj_pool_release(pool);
-    } else {
-		
-        status = pjsua_im_send(acc_id, &to, mime_type, 
-			&content, NULL, NULL);	
-    }
+    }
+
+    status = pjsua_im_send(acc_id, &to, mime_type, &content, 
+			   &msg_data, (void *)user_data);
+    if (pool)
+	pj_pool_release(pool);
     
     return Py_BuildValue("i",status);
@@ -2343,32 +2164,37 @@
     int acc_id;
     pj_str_t to;
-    PyObject * st;
+    PyObject *pTo;
     int is_typing;
     pjsua_msg_data msg_data;
-    PyObject * omdObj;
-    PyObj_pjsua_msg_data * omd;
-    pj_pool_t * pool;
-
-    PJ_UNUSED_ARG(pSelf);
-
-    if (!PyArg_ParseTuple(pArgs, "iOiO", &acc_id, &st, &is_typing, &omdObj)) {
+    PyObject *pMsgData;
+    pj_pool_t *pool = NULL;
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "iOiO", &acc_id, &pTo, &is_typing, 
+			  &pMsgData)) 
+    {
         return NULL;
     }
 	
-    to = PyString_to_pj_str(st);
-
-    if (omdObj != Py_None) {
-        omd = (PyObj_pjsua_msg_data *)omdObj;
-	msg_data.content_type = PyString_to_pj_str(omd->content_type);
-	msg_data.msg_body = PyString_to_pj_str(omd->msg_body);
-        pool = pjsua_pool_create("pjsua", POOL_SIZE, POOL_SIZE);
+    to = PyString_ToPJ(pTo);
+
+    if (pMsgData != Py_None) {
+	PyObj_pjsua_msg_data *omd;
+
+        omd = (PyObj_pjsua_msg_data *)pMsgData;
+	msg_data.content_type = PyString_ToPJ(omd->content_type);
+	msg_data.msg_body = PyString_ToPJ(omd->msg_body);
+        pool = pjsua_pool_create("pytmp", POOL_SIZE, POOL_SIZE);
 
         translate_hdr(pool, &msg_data.hdr_list, omd->hdr_list);
-        status = pjsua_im_typing(acc_id, &to, is_typing, &msg_data);	
-        pj_pool_release(pool);
-    } else {
-        status = pjsua_im_typing(acc_id, &to, is_typing, NULL);
-    }
-    return Py_BuildValue("i",status);
+    }
+
+    status = pjsua_im_typing(acc_id, &to, is_typing, &msg_data);
+
+    if (pool)
+	pj_pool_release(pool);
+
+    return Py_BuildValue("i", status);
 }
 
